Index: sounds-extra.txt
===================================================================
RCS file: /usr/cvsroot/asterisk-sounds/sounds-extra.txt,v
retrieving revision 1.3
diff -u -r1.3 sounds-extra.txt
--- sounds-extra.txt	10 Apr 2004 18:18:52 -0000	1.3
+++ sounds-extra.txt	1 May 2004 22:45:26 -0000
@@ -12,13 +12,10 @@
 
 %press-star-cancel.gsm%Press star to cancel.
 
-
 %international-call.gsm%International call
 
-
 %to-dial-by-name-press.gsm%to dial by name, press
 
-
 %directory.gsm%directory
 
 %dollars.gsm%dollars
@@ -123,596 +120,400 @@
 
 %driving-directions.gsm%for driving directions to our location, press
 
-
 %available-options.gsm%available options
 
-
 %to-record-call.gsm%to record call
 
-
 %turn-off-recording.gsm%to turn off call recording
 
-
 %groovy.gsm%groovy
 
-
 %activated.gsm%activated
 
-
 %de-activated.gsm%de-activated
 
-
 %this-call-may-be.gsm%This call may be
 
-
 %recorded.gsm%recorded
 
-
 %monitored.gsm%monitored
 
-
 %for-quality-purposes.gsm%for quality assurance purposes
 
-
 %because-paranoid.gsm%because we're paranoid
 
-
 %channel-insecure-warn.gsm%This voice path is insecure - do not discuss classified information or use project codewords.
 
-
 %channel-secure.gsm%This voice path is secure.
 
-
 %for.gsm%for
 
-
 %to-hear-menu-again.gsm%to hear this menu again
 
-
 %menu.gsm%menu
 
 %enter-ext-of-person.gsm%enter the extension of the person you are trying to reach
 
-
 %after-the-tone.gsm%after the tone
 
-
 %call-quality-menu.gsm%Please rate the quality of the call you just made.  Use the keys one through four to rate the voice quality of the call, with one being the best quality, and four meaning that it was very difficult to understand the other party.  Press five if the call was prematurely disconnected.  Press six if the call was never completed.  Press seven if one direction of the call could not be heard.  Press eight if there were other difficulties.
 
-
 %star-for-menu-again.gsm%Press the star key to hear this menu again
 
-
 %please-enter-the.gsm%Please enter the
 
-
 %conference-call.gsm%conference call
 
-
 %chat-room.gsm%chat room
 
-
 %extension.gsm%extension
 
-
 %channel.gsm%channel
 
 %you-wish-to-join.gsm%you wish to join
 
-
 %card-is-invalid.gsm%card is invalid
 
-
 %card-balance-is.gsm%card balance is
 
-
 %too-low.gsm%too low
 
-
 %dollars.gsm%dollars
 
-
 %cents.gsm%cents
 
-
 %minutes.gsm%minutes
 
-
 %card-number.gsm%card number
 
-
 %your.gsm%your
 
-
 %please-contact-tech-supt.gsm%Please contact technical support
 
-
 %doing-enum-lookup.gsm%Doing an e-num lookup
 
-
 %enum-lookup-failed.gsm%e-num lookup failed
 
-
 %enum-lookup-successful.gsm%e-num lookup successful
 
-
 %not-auth-pstn.gsm%You at not authorized to call out using the PSTN
 
-
 %pin-number-accepted.gsm%Pin number accepted
 
-
 %speed-dial.gsm%Speed-dial
 
-
 %is-not-set.gsm%is not set
 
-
 %has-been-cleared.gsm%has been cleared
 
-
 %has-been-set-to.gsm%has been set to
 
-
 %is-set-to.gsm%is set to
 
-
 %call-fwd-on-busy.gsm%Call-Forward on Busy
 
-
 %call-fwd-unconditional.gsm%Call-Forward Unconditional
 
-
 %call-fwd-no-ans.gsm%Call-Forward on No Answer
 
-
 %call-fwd-parallel.gsm%Call-Forward Parallel
 
-
 %call-fwd-cancelled.gsm%call forward cancelled
 
-
 %pls-wait-connect-call.gsm%Please wait, while I connect your call.
 
-
 %busy-pls-hold.gsm%All our lines are currently busy.  Please hold and someone will be with you shortly.
 
-
 %ext-or-zero.gsm%Please dial the extension of the person you're trying to reach, or 0 for an operator.
 
-
 %discon-or-out-of-service.gsm%The number you have dialed has been disconnected or is no longer in service.  Please check the number, and try your call again.
 
-
 %hours.gsm%hours
 
-
 %seconds.gsm%seconds
 
-
 %at.gsm%at
 
-
 %received.gsm%received
 
-
 %yesterday.gsm%yesterday
 
-
 %today.gsm%today
 
-
 %tomorrow.gsm%tomorrow
 
-
 %first.gsm%first
 
-
 %second.gsm%second
 
-
 %third.gsm%third
 
-
 %fourth.gsm%fourth
 
-
 %fifth.gsm%fifth
 
-
 %sixth.gsm%sixth
 
-
 %seventh.gsm%seventh
 
-
 %eighth.gsm%eighth
 
-
 %ninth.gsm%ninth
 
-
 %tenth.gsm%tenth
 
-
 %eleventh.gsm%eleventh
 
-
 %twelveth.gsm%twelveth
 
-
 %thirteenth.gsm%thirteenth
 
-
 %fourteenth.gsm%fourteenth
 
-
 %fifteenth.gsm%fifteenth
 
-
 %sixteenth.gsm%sixteenth
 
-
 %seventeenth.gsm%seventeenth
 
-
 %eighteenth.gsm%eighteenth
 
-
 %nineteenth.gsm%nineteenth
 
-
 %twentieth.gsm%twentieth
 
-
 %thirtieth.gsm%thirtieth
 
-
 %star.gsm%star
 
-
 %pound.gsm%pound
 
-
 %hash.gsm%hash
 
-
 %octothorpe.gsm%octothorpe
 
-
 %office-iguanas.gsm%The office has been overrun with iguanas.
 
-
 %gambling-drunk.gsm%We're off gambling and getting drunk.
 
-
 %nobody-but-chickens.gsm%Nobody here but us chickens!
 
-
 %deadbeat.gsm%Deadbeat!
 
-
 %pls-try-again.gsm%Please try again!
 
-
 %the-monkeys-twice.gsm%The monkeys!  THE MONKEYS!
 
-
 %pls-enter-vm-password.gsm%Please enter your voicemail password
 
-
 %your-msg-has-been-saved.gsm%Your message has been saved
 
-
 %goodbye.gsm%Goodbye!
 
-
 %pls-enter-conf-password.gsm%Please enter the conference password
 
-
 %the-party-you-are-calling.gsm%The party you are calling
 
-
 %is-curntly-unavail.gsm%is currently unavailable
 
-
 %is-curntly-busy.gsm%is currently busy
 
-
 %for-accounting.gsm%For accounting
 
-
 %for-billing.gsm%For billing
 
-
 %for-tech-support.gsm%For technical support
 
-
 %seconds.gsm%seconds
 
-
 %and-prs-pound-whn-finished.gsm%And press pound when finished
 
-
 %if-this-is-correct-press.gsm%if this is correct, press
 
-
 %otherwise-press.gsm%otherwise press
 
-
 %you-entered.gsm%You entered
 
-
 %im-sorry.gsm%I'm sorry
 
-
 %that-is-not-rec-phn-num.gsm%That is not a recognized phone number
 
-
 %please-try-again.gsm%Please try again
 
-
 %sixtieth.gsm%sixtieth
 
-
 %seventieth.gsm%seventieth
 
-
 %eightieth.gsm%eightieth
 
-
 %ninetieth.gsm%ninetieth
 
-
 %hundredth.gsm%hundredth
 
-
 %thousandth.gsm%thousandth
 
-
 %millionth.gsm%millionth
 
-
 %billionth.gsm%billionth
 
-
 %negative.gsm%negative
 
-
 %zulu.gsm%zulu
 
-
 %gmt.gsm%greenwich mean time
 
-
 %time.gsm%time
 
-
 %eastern.gsm%eastern
 
-
 %central.gsm%central
 
-
 %mountain.gsm%mountain
 
-
 %pacific.gsm%pacific
 
-
 %atlantic.gsm%atlantic
 
-
 %standard.gsm%standard
 
-
 %european.gsm%european
 
-
 %daylight.gsm%daylight
 
-
 %time.gsm%time
 
-
 %pls-entr-num-uwish2-call.gsm%please enter the number you wish to call
 
-
 %then-press-pound.gsm%then press pound
 
-
 %year.gsm%year
 
-
 %month.gsm%month
 
-
 %day.gsm%day
 
-
 %from-unknown-caller.gsm%from an unknown caller
 
-
 %your-msg-is-too-short.gsm%your message is too short
 
-
 %the-num-i-have-is.gsm%the number I have is
 
-
 %to-call-this-number.gsm%to call this number
 
-
 %to-enter-a-diff-number.gsm%to enter a different number
 
-
 %to-enter-a-number.gsm%to enter a number
 
-
 %to-compose-a-message.gsm%to compose a message
 
-
 %to-erase-yr-temp-grtg.gsm%to erase your temporary greeting
 
-
 %to-rec-yr-temp-grtg.gsm%to record your temporary greeting
 
-
 %to-rerecord-yr-message.gsm%to re-record your message
 
-
 %your-temp-greeting.gsm%your temporary greeting
 
-
 %has-expired.gsm%has expired
 
-
 %is-in-use.gsm%is in use
 
-
 %will-expire.gsm%will expire
 
-
 %will-not-expire.gsm%will not expire
 
-
 %to-change-exp-date.gsm%to change the expiration date
 
-
 %to-send-a-reply.gsm%to send a reply
 
-
 %to-call-prson-w-sent-msg.gsm%to call the person who sent this message
 
-
 %to-place-outgoing-call.gsm%to place an outgoing call
 
-
 %if-grtg-played-indefinately.gsm%if this greeting should be played indefinately
 
-
 %if-grtg-should-expire-at.gsm%if this greeting should expire at
 
-
 %midnight-tonight.gsm%midnight tonight
 
-
 %midnight.gsm%midnight
 
-
 %tonight.gsm%tonight.gsm%
 
-
 %midnight-tomorrow-night.gsm%midnight tomorrow night
 
-
 %tomorrow-night.gsm%tomorrow-night
 
-
 %another-time.gsm%another time
 
-
 %to-hear-msg-envelope.gsm%to hear the message envelope
 
-
 %say-temp-msg-prs-pound.gsm%say your temporary message and then press the pound key
 
-
 %to-accept-recording.gsm%to accept this recording
 
-
 %to-listen-to-it.gsm%to listen to it
 
-
 %to-rerecord-it.gsm%to re-record it
 
-
 %to-reach-operator.gsm%to reach an operator
 
-
 %to-cancel-this-msg.gsm%to cancel this message
 
-
 %nothing-recorded.gsm%nothing has been recorded
 
-
 %speak-louder.gsm%please speak louder to ensure a clear recording
 
-
 %dont-know-who-sent.gsm%I'm afraid I don't know who sent this message
 
-
 %no-reply-no-mailbox.gsm%you cannot reply to this message because the sender does not have a mailbox
 
-
 %invalid-date.gsm%invalid date
 
-
 %message-from.gsm%message from
 
-
 %target-attendant.gsm%target attendant
 
-
 %outside-transfer.gsm%outside transfer
 
-
 %default-attendant.gsm%default attendant
 
-
 %pls-ent-num-transfer.gsm%please enter the number to use for call transfer
 
-
 %ent-target-attendant.gsm%please enter the number of the extension to use for your target attendant
 
-
 %to-use-def-attendant.gsm%to use the default attendant, just press pound
 
-
 %no-911-1.gsm%this line does not support nine one one services [quickly]
 
-
 %no-911-2.gsm%this line does not support nine one one services 
 
-
 %no-112-1.gsm%this line does not support one one two services [quickly]
 
-
 %no-112-2.gsm%this line does not support one one two services
 
-
 %you-are-caller-num.gsm%you are caller number
 
-
 %you-are-curr-call-num.gsm%you are currently caller number
 
-
 %in-the-queue.gsm%in the queue
 
-
 %in-the-line.gsm%in the line
 
-
 %wtng-to-spk-w-rep.gsm%waiting to speak with a representative
 
-
 %first-in-line.gsm%your call is now first in line, and will be answered by the first available representative
 
-
 %these-are-currently.gsm%these are currently
 
-
 %calls-waiting-for-rep.gsm%calls waiting to speak with a representative
 
-
 %est-hold-time-is.gsm%the estimated hold time is currently
 
-
 %minutes.gsm%minutes
 
-
 %thnk-u-for-patience.gsm%thank you for your patience
 
-
 %a.gsm%a
 
 %b.gsm%b
@@ -1051,82 +852,56 @@
 
 %alpha.gsm%Alpha
 
-
 %bravo.gsm%Bravo
 
-
 %charlie.gsm%Charlie
 
-
 %delta.gsm%Delta
 
-
 %echo.gsm%Echo
 
-
 %foxtrot.gsm%Foxtrot
 
-
 %golf.gsm%Golf
 
-
 %hotel.gsm%Hotel
 
-
 %india.gsm%India
 
-
 %juliet.gsm%Juliet
 
-
 %kilo.gsm%Kilo
 
-
 %lima.gsm%Lima
 
-
 %mike.gsm%Mike
 
-
 %november.gsm%November
 
-
 %oscar.gsm%Oscar
 
-
 %papa.gsm%Papa
 
-
 %quebec.gsm%Quebec
 
-
 %romeo.gsm%Romeo
 
-
 %sierra.gsm%Sierra
 
-
 %tango.gsm%Tango
 
-
 %uniform.gsm%Uniform
 
-
 %victor.gsm%Victor
 
-
 %whiskey.gsm%Whiskey
 
-
 %xray.gsm%Xray
 
-
 %yankee.gsm%Yankee
 
-
 %zulu.gsm%Zulu
 
-
 %niner.gsm%Niner
 
 %you-sound-cute.gsm%So, _you_ sound cute.
@@ -1192,3 +967,333 @@
 %8.gsm%8 sec silence
 
 %9.gsm%9 sec silence
+
+%what-time-it-is.gsm%Do you have any idea what <emph> time </emph> it is?
+
+%what-time-it-is2.gsm%Do you have any idea what <emph> time </emph> it is?
+
+%at-tone-time-exactly.gsm%At the sound of the tone, the time will be exactly
+
+%if-you-know-the.gsm%if you know the
+
+%that-you-require.gsm%that you require
+
+%it-now.gsm%it now
+
+%to-collect-voicemail.gsm%to collect voicemail
+
+%to-join-a-meeting.gsm%to join a meeting
+
+%accessible-through-system.gsm%accessible through this system
+
+%starting-with-either.gsm%starting with either
+
+%digit.gsm%digit
+
+%digits.gsm%digits
+
+%list.gsm%list
+
+%user.gsm%user
+
+%extensions.gsm%extensions
+
+%office-code.gsm%office code
+
+%speak-to-the-operator.gsm%speak to the operator
+
+%uk.gsm%UK
+
+%welcome.gsm%welcome
+
+%no-empty-conferences.gsm%No empty conferences currently exist.
+
+%entering-conf-number.gsm%You are entering conference number
+
+%an-error-has-occured.gsm%An error has occured.
+
+%unconditional.gsm%unconditional
+
+%call-forwarding.gsm%Call forwarding
+
+%on-busy.gsm%on busy
+
+%on-no-answer.gsm%on no answer
+
+%enabled.gsm%enabled
+
+%disabled.gsm%disabled
+
+%do-not-disturb.gsm%Do not disturb
+
+%error-number.gsm%error number
+
+%uh-oh1.gsm%Uh oh!  [in a cutesy, Teletubbie's like voice] 
+
+%uh-oh2.gsm%Uh oh!  [in a cutesy, Teletubbie's like voice] 
+
+%teletubbie-murder.gsm%has been brutally murdered and mutilated by the Teletubbies. 
+
+%thank-you-cooperation.gsm%Thank you for your cooperation.
+
+%computer-friend1.gsm%The computer is your friend.
+
+%computer-friend2.gsm%The computer is your friend.
+
+%asterisk-friend.gsm%Asterisk is your friend.
+
+%walks-into-bar-mail.gsm%A man walks into a bar, sits down and ... welcome to Comedian Mail!
+
+%you-dialed-wrong-number.gsm%You have dialed the wrong number.
+
+%jedi-extension-trick.gsm%This is not the extension you are looking for.
+
+%pls-hold-while-try.gsm%Please hold while we try to connect you.
+
+%busy-hangovers.gsm%We're all busy with our hangovers.
+
+%lines-complaining-customers.gsm%All lines are full of complaining customers.
+
+%if-rotary-phone.gsm%If you have a rotary phone, please stay on the line after the menu.
+
+%thank-you-for-calling.gsm%Thank you for calling.
+
+%system-status-msg.gsm%Please listen carefully to the following system status message.
+
+%all-reps-busy.gsm%All of our representatives are currently busy.
+
+%pls-lv-msg-will-contact.gsm%Please leave a message after the tone and a representative will contact you as soon as possible.
+
+%pls-stay-on-line.gsm%Please stay on the line and your call will be answered by the next available representative.
+
+%to-be-called-back.gsm%To be called back when a representative is available, press-- 
+
+%now.gsm%now.
+
+%enter-phone-number10.gsm%Please enter your ten-digit telephone number, area code first.
+
+%please-enter-your.gsm%Please enter your
+
+%post-entry-pound.gsm%digit account number, skipping any punctuation, followed by the pound key.
+
+%press-1.gsm%Press 1
+
+%press-2.gsm%Press 2
+
+%press-3.gsm%Press 3
+
+%press-4.gsm%Press 4
+
+%press-5.gsm%Press 5
+
+%press-6.gsm%Press 6
+
+%press-7.gsm%Press 7
+
+%press-8.gsm%Press 8
+
+%press-9.gsm%Press 9
+
+%press-hash.gsm%Press hash
+
+%press-star.gsm%Press star
+
+%press-pound.gsm%Press pound
+
+%for-wakeup-call.gsm%For a wakeup call...
+
+%wakeup-call.gsm%Wakeup call
+
+%this-is-yr-wakeup-call.gsm%This is your wakeup call.
+
+%to-snooze-for.gsm%To snooze for...
+
+%to-rqst-wakeup-call.gsm%To request a wakeup call...
+
+%to-confirm-wakeup.gsm%To confirm a wakeup call...
+
+%to-cancel-wakeup.gsm%To cancel a wakeup call...
+
+%enter-a-time.gsm%Enter a time using 4 digits.  Start with a zero for hours less than ten. 
+
+%1-for-am-2-for-pm.gsm%Press 1 for A.M, or 2 for P.M.
+
+%rqsted-wakeup-for.gsm%You have requested a wakeup call for...
+
+%not-rqsted-wakeup.gsm%You have not requested a wakeup call.
+
+%wakeup-call-cancelled.gsm%Your wakeup call has been cancelled.
+
+%for-english-press.gsm%For english, press
+
+%continue-english-press.gsm%To continue in english, press
+
+%to-extension.gsm%to extension 
+
+%feature-not-avail-line.gsm%That feature is not available on this line
+
+%save-announce-press.gsm%To save this announcement, press
+
+%to-rerecord-announce.gsm%To rerecord this announcement, press
+
+%minus.gsm%minus
+
+%plus.gsm%plus
+
+%times.gsm%times
+
+%divided-by.gsm%divided by
+
+%equals.gsm%equals
+
+%your-account.gsm%Your account
+
+%has-been.gsm%has been
+
+%on-monthly-tel-stment.gsm%on your monthly telephone statement
+
+%info-about-last-call.gsm%Information about your last call
+
+%flagged-for-lea.gsm%has been flagged for retrvial by law enforcement officials
+
+%lea-may-request-info.gsm%Law enforcement officials may request this information
+
+%within.gsm%within
+
+%the-next.gsm%the next
+
+%the-number-u-dialed.gsm%The number you have dialed
+
+%the-new-number-is.gsm%The new number is
+
+%has-been-changed-to.gsm%has been changed to
+
+%has-been-disconnected.gsm%has been disconnected
+
+%no-longer-in-service.gsm%is no longer in service
+
+%temp-disconnected.gsm%has been temporarialy disconnected
+
+%at-customers-request.gsm%at the customers request
+
+%reassigned-new-areacode.gsm%has been reassigned in another areacode
+
+%pls-try-area-code.gsm%please try area code
+
+%not-yet-assigned.gsm%has not yet been assigned
+
+%calls-taken-by.gsm%calls are being taken by
+
+%no-info-about-number.gsm%no further information is available about this number
+
+%all-circuits-busy-now.gsm%All circuits are busy now
+
+%pls-try-call-later.gsm%please try your call again later
+
+%a-charge-for-this-svc.gsm%A charge for this service
+
+%for-the-weather.gsm%For the weather
+
+%by.gsm%by
+
+%telephone-number.gsm%telephone number
+
+%zip-code.gsm%zip code
+
+%address.gsm%address
+
+%international-call.gsm%international call
+
+%please-try.gsm%please try
+
+%www-switchboard-com.gsm%www.switchboard.com
+
+%directory-assistance.gsm%directory assistance
+
+%days.gsm%days
+
+%weeks.gsm%weeks
+
+%months.gsm%months
+
+%years.gsm%years
+
+%if-u-know-ext-dial.gsm%If you know the extension of the party you wish to reach, dial it now. 
+
+%company-dir-411.gsm%To access our company directory, dial 411 or dial zero to leave a message in our general mailbox.
+
+%hold-or-dial.gsm%Please continue to hold or dial zero to leave a message in our general mailbox.
+
+%call-forward.gsm%Call Forward
+
+%current-time-is.gsm%The current time is
+
+%will-reflect-charge-of.gsm%will reflect a charge of 
+
+%added-to.gsm%added to
+
+%wish-to-continue.gsm%do you wish to continue?
+
+%for-yes-press.gsm%for yes, press
+
+%for-no-press.gsm%for no, press
+
+%or-press.gsm%or press
+
+%to-hear-msg-again.gsm%to hear this message again.
+
+%for-a-list-of.gsm%For a list of 
+
+%that-number.gsm%that number
+
+%our-business-hours-are.gsm%Our business hours are
+
+%for-investor-relations.gsm%for investor relations, press 
+
+%for-louie-louie.gsm%for the lyrics to louie, louie, press 
+
+%lyrics-louie-louie.gsm%[
+        Louie Louie, me gotta go
+        Louie Louie, me gotta go
+        Fine little girl she waits for me
+        Me catch the ship for cross the sea
+        Me sail the ship all alone
+        Me never thinks me make it home
+        (chorus)
+        Three nights and days me sail the sea
+        Me think of girl constantly
+        On the ship I dream she there
+        I smell the rose in her hair
+        (chorus, guitar solo)
+        Me see Jamaica moon above
+        It won't be long, me see my love
+        I take her in my arms and then
+        Me tell her I never leave again]
+
+%hear-toilet-flush.gsm%to hear a toilet flush, press 
+
+%hear-odd-noise.gsm%to hear an odd noise, press 
+
+%infuriate-tech-staff.gsm%to infuriate our tech staff with your obvious questions, press [X]
+
+# Note: [T] denotes "trailing" spoken emphasis; phrase is meant to be at end of sentence.
+
+%T-is-not-available.gsm%[T] is not available 
+
+%T-to-leave-msg.gsm%[T] to leave a message
+
+%T-to-rtrn-to-main-menu.gsm%[T] to return to the main menu
+
+%T-to-reach-main-office.gsm%[T] to reach the main office
+
+%T-changed-to.gsm%[T] has been changed to [Extension Y]
+
+%T-to-hear-cur-ancmnt.gsm%[T] to hear the current announcement
+
+%T-to-rec-ancmnt.gsm%[T] to rerecord this announcement
+
+%T-to-enable-ancmnt.gsm%[T] to enable this announcement
+
+%T-to-disable-ancmnt.gsm%[T] to disable this announcement
+
+%hold-or-dial-0.gsm%Continue to hold or dial 0 to leave a message in our general mailbox